/*
 * Project: irond
 * Package: src.de.fhhannover.inform.iron.mapserver.datamodel
 * File:    SearchResultBuilderImpl.java
 *
 * Copyright (C) 2010-2011 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.iron.mapserver.datamodel;

import java.util.List;

import de.fhhannover.inform.iron.mapserver.datamodel.graph.MetadataContainer;
import de.fhhannover.inform.iron.mapserver.datamodel.graph.meta.Metadata;
import de.fhhannover.inform.iron.mapserver.messages.ResultItem;
import de.fhhannover.inform.iron.mapserver.messages.SearchResult;

/**
 * Implementation of the interface {@link SearchResultBuilder}
 * 
 * @author aw
 * @version 0.1
 *
 */

public class SearchResultBuilderImpl extends SearchResultBuilder {
	
	
	private SearchResult searchResult;
	
	public SearchResultBuilderImpl(SearchResult sRes) {
		searchResult = sRes;
	}
	
	@Override
	public void addMetadata(MetadataContainer mc, Metadata m) {
		searchResult.addMetadata(mc, m);
	}

	@Override
	public void addMetadata(MetadataContainer mc, List<Metadata> mdlist) {
		searchResult.addMetadata(mc, mdlist);
	}

	@Override
	public void addContainer(MetadataContainer mc) {
		searchResult.addMetadataContainer(mc);
	}

	@Override
	public SearchResult getResult() {
		return searchResult;
	}

	@Override
	public void filter(Filter resultFilter) {
		for (ResultItem ri : searchResult.getResultItems())
			ri.filter(resultFilter);
	}

	@Override
	public int getByteCount() {
		return searchResult.getByteCount();
	}
}
